import loadScript from "./load-script";

function isValidVue(Vue: any) {
  return (
    typeof Vue === "object" &&
    Vue.version[0] === "3" &&
    !!Vue.compile &&
    !!Vue.Teleport
  );
}

export default function () {
  return new Promise((resolve) => {
    if (window.$HFC_VUE) {
      resolve(true);
      return;
    }

    if (isValidVue(window.Vue)) {
      window.$HFC_VUE = window.Vue;
      resolve(true);
      return;
    }

    let vueValue = typeof window.Vue !== "undefined" ? window.Vue : undefined;

    Object.defineProperty(window, "Vue", {
      get: function () {
        return vueValue;
      },
      // hook for set vue3
      set: function (value) {
        if (window.$HFC_VUE) {
          vueValue = value;
          return;
        }

        if (isValidVue(value)) window.$HFC_VUE = value;
      },
    });

    loadScript(window.$HFC_CDN_URL + "/vue@3.1.5/dist/vue.global.prod.js").then(() => {
      resolve(true);
    });
  });
}
